.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "1.00",
.\"     date            = "02 July 1996",
.\"     time            = "07:56:21 MDT",
.\"     filename        = "epsutil.man",
.\"     address         = "Center for Scientific Computing
.\"                        Department of Mathematics
.\"                        University of Utah
.\"                        Salt Lake City, UT 84112
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     URL             = "http://www.math.utah.edu/~beebe",
.\"     checksum        = "19840 832 3264 21927",
.\"     email           = "beebe@math.utah.edu (Internet)",
.\"     codesource      = "ftp://ftp.math.utah.edu/pub/misc/index.html#epsutil-1.00",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "background; clipping; color; EPS;
.\"                        Encapsulated PostScript; framing; landscape;
.\"                        linewidth; portrait; PostScript utility;
.\"                        rotation; scaling; translation",
.\"     supported       = "yes",
.\"     docstring       = "This file is the UNIX nroff/troff manual page
.\"                        documentation for epsutil, a utility for
.\"                        manipulating Encapsulated PostScript files.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\" ====================================================================
.if t .ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.if n .ds Ps PostScript
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.TH EPSUTIL 1 "02 July 1996" "Version 1.00"
.\"=====================================================================
.SH NAME
epsutil \- a tool for manipulating Encapsulated PostScript files
.\"=====================================================================
.SH SYNOPSIS
.na
.B epsutil
.BI "[ BG" =color-name ]
.if n .ti +8n
.BI "[ BOUNDINGBOX" =llx,lly,urx,ury ]
.if n .ti +8n
.BI "[ CHECK" =check ]
.if n .ti +8n
.BI "[ CLIP" =clip ]
.if t .ti +.5i
.if n .ti +8n
.BI "[ CMYK" =cyan,magenta,yellow,black ]
.if n .ti +8n
.BI "[ FRAME" =frame-thickness ]
.if n .ti +8n
.BI "[ GRAY" =gray ]
.if t .ti +.5i
.BI "[ GRID" =grid ]
.if n .ti +8n
.BI "[ HEIGHT" =height ]
.if n .ti +8n
.BI "[ HSB" =hue,saturation,brightness ]
.if n .ti +8n
.if t .ti +.5i
.BI "[ ID" =idx,idy[,fontsize[,fontname]] ]
.if n .ti +8n
.BI "[ LINEWIDTHSCALE" =line-width-scale ]
.if n .ti +8n
.if t .ti +.5i
.BI "[ MAXLINEWIDTH" =maximum-line-width ]
.if n .ti +8n
.BI "[ MINLINEWIDTH" =minimum-line-width ]
.if t .ti +.5i
.if n .ti +8n
.BI "[ OXY" =origin ]
.BI "[ OX" =llx-origin ]
.BI "[ OY" =lly-origin ]
.if n .ti +8n
.if t .ti +.5i
.BI "[ PSCODE" "='\*(Ps\& code'" ]
.if n .ti +8n
.BI "[ PSFILE" =psfile,psfile,.\|.\|. ]
.if n .ti +8n
.if t .ti +.5i
.BI "[ RGB" =red,green,blue ]
.if n .ti +8n
.BI "[ RGBFILE" =rgbfile ]
.if n .ti +8n
.BI "[ ROTATE" =degrees ]
.if n .ti +8n
.if t .ti +.5i
.BI "[ SXY" =scale-factor ]
.if n .ti +8n
.BI "[ SX" =x-scale-factor ]
.BI "[ SY" =y-scale-factor ]
.if n .ti +8n
.BI "[ WIDTH" =width ]
.if n .ti +8n
.if t .ti +.5i
.I  "[<] old-PS-file >new-PS-file"
.ad
.\"=====================================================================
.SH DESCRIPTION
.B epsutil
filters an Encapsulated \*(Ps\& file, or files,
named on the command line (or
.I stdin
if
no filenames are given), to
.IR stdout ,
inserting wrapper \*(Ps\& to optionally provide
.RS
.TP \w'\(bu'u+1n
\(bu
background color,
.TP
\(bu
BoundingBox adjustment and measurement,
.TP
\(bu
checking for non-EPS operators,
.TP
\(bu
clipping,
.TP
\(bu
framing,
.TP
\(bu
linewidth scaling,
.TP
\(bu
\*(Ps\& alteration,
.TP
\(bu
rotation,
.TP
\(bu
scaling, and
.TP
\(bu
translation.
.RE
.PP
The output file fully conforms to the
.I "\*(Ps\& Document Structuring Conventions"
defined in Appendix G of the
.IR "\*(Ps\& Language Reference Manual" ,
Second Edition, Addison-Wesley (1985), ISBN
0-201-10174-2 (the Adobe red book).
.PP
The output of this program is also suitable input
to it; after four filtering steps with 90-degree
rotation selected, the original figure will be
recovered, although the output \*(Ps\& file will
be about 4300 bytes larger for each rotation
because of the wrapper overhead.
.PP
The original command line that was used to create
the output file is preserved in a
.I %%Title
comment in the second line of the output file, as
a record of the requested transformations.
.PP
A verbatim copy of the original file, minus any
.I %%EOF
comments, is embedded in the output between the
.I %%BeginDocument
and
.I %%EndDocument
lines, where it can be recovered simply by
stripping the wrapping \*(Ps\&.
.\"=====================================================================
.SH OPTIONS
.B epsutil
options take the form of
.BI NAME =value
assignments, rather than the more usual
hyphen-prefixed options common in other UNIX
utilities.  If an option is given more than once,
only the last one is used.
.PP
If no dimension unit is specified in the variable
values described below, physical dimensions are
assumed to be measured in standard \*(Ps\& units
of big points:
.PP
        72bp = 1in = 25.4mm
.PP
Otherwise, any of the \*(Te\& dimension units of
.I bp
(big point),
.I cc
(cicero),
.I cm
(centimeter),
.I dd
(didot point),
.I in
(inch),
.I mm
(millimeter),
.I pc
(pica),
.I pt
(point), or
.I sp
(scaled point), may suffix a number, and the value
will be converted to big points internally.
.\"---------------------------------------------------------------------
.SS "Background color"
A background color can be specified as a named
color, or as a triple (or, for
.BR CMYK ,
quadruple) of numbers, each in the range
0\|.\|.\|1.  The numbers must separated by any
character other than a digit or period.  Comma or
slash is a readable choice for a separator
character, and avoids the need to quote the values
to protect them from possible shell
interpretation.
.PP
Five color models are available.  The models are
tried in alphabetical order: the first one
specified is used, and any settings for the others
are silently ignored.
.PP
For
.BR BG ,
the value is the name of a color found in either
the file specified by the
.BI RGBFILE =rgbfile
option, or else in the X Window System
.I rgb.txt
color mapping file. These files associate red,
green, and blue intensities with named colors;
their lines contain three numbers in the range
0..255, followed by a color name.  The
.I rgb.txt
file is found by searching a built-in directory
path that covers all major UNIX systems; that path
can be overridden by defining a value for the
environment variable
.BR RGBPATH .
For example, on an IBM RS/6000 AIX system, you
could set that variable to
.I /usr/lpp/X11/lib/X11/It_IT
to get Italian color names.
.PP
In
.BR CMYK ,
values for cyan, magenta, and yellow are provided
(0 means no color, 1 means full color), and then
an amount of black (0 means none, 1 means
completely black) is added to darken the color.
.PP
In
.BR GRAY ,
0 is black and 1 is white.
.BI GRAY =g
is equivalent to
.BI RGB =g,g,g.
.PP
In
.BR HSB ,
hue runs through the rainbow (approximately,
red=0, orange=0.1, limegreen=0.2, green=0.3,
cyan=0.5, blue=0.6, magenta=0.8, deeppink=0.9,
red=1). Saturation goes from 0 (no color == black)
to 1 (full color).  Brightness goes from 0 (dark)
to 1 (bright).
.PP
In
.BR RGB ,
major colors are:
.RS
.nf
Black   0,0,0
Red     1,0,0
Green   0,1,0
Yellow  1,1,0
Blue    0,0,1
Magenta 1,0,1
Cyan    0,1,1
White   1,1,1
.fi
.RE
.PP
Sample options:
.RS
.nf
.BI BG =bisque
.BI CMYK =1,0,0,0.2
.BI GRAY =0.9
.BI HSB =0.5,1,,0.8
.BI RGB =1,1,0
.BI RGBFILE =mycolors.rgb
.fi
.RE
.\"---------------------------------------------------------------------
.SS "BoundingBox"
Encapsulated \*(Ps\& files are required to contain
a
.I %%BoundingBox
comment that defines the lower-left and
upper-right corner coordinates in big points.
Sadly, most \*(Ps\&-producing programs produce
(sometimes wildly) incorrect coordinate values in
this comment, so manual adjustment is frequently
necessary.  Also, sometimes only a portion of the
original figure is required, necessitating
definition of a new BoundingBox.
.PP
To avoid the need for modifying the original
\*(Ps\& file, the two corner coordinate pairs can
be specified as four optionally-dimensioned
numbers for the value of the
.B BOUNDINGBOX
option.  The numbers can be separated by any
characters other than plus, minus, digits, period,
or lowercase letters; comma or slash are readable
choices.  Values specified this way override those
in the
.I %%BoundingBox
comment.
.PP
When a
.B BOUNDINGBOX
value is given, especially if it covers only a
portion of the original figure, clipping should be
selected.
.PP
Although fractional dimensions are accepted, after
converting to big points, the values actually used
will be rounded down to the nearest integer at the
lower-left corner, and up to the nearest integer
at the upper-right corner.  This is a requirement
of the
.IR "\*(Ps\& Document Structuring Conventions" .
.PP
Sample options:
.RS
.nf
.BI BOUNDINGBOX =10,20,500,750
.BI BOUNDINGBOX "=10 20 500 750"
.BI BOUNDINGBOX =0.1in,0.3in,18cm,25cm
.BI BOUNDINGBOX =10mm/20mm/30pc/40pc
.fi
.RE
.\"---------------------------------------------------------------------
.SS "BoundingBox frame"
A rectangular frame of a specified line thickness
will be drawn around the
.I outside
of the original BoundingBox if the
.BI FRAME =frame-thickness
option is given.
.PP
If linewidth scaling is requested, the frame will
also be affected by the scaling.
.PP
The output BoundingBox will automatically be
enlarged by the twice the frame thickness, and any
.B MAXLINEWIDTH
value will be adjusted upward if necessary to
ensure that the frame can be drawn properly.
.PP
Sample options:
.RS
.nf
.BI FRAME =3
.BI FRAME =3mm
.fi
.RE
.\"---------------------------------------------------------------------
.SS "Checking for non-EPSF operators"
If a non-zero value of the
.BI CHECK =check
option is given, check for the presence of \*(Ps\&
operators that are not permitted in EPS files.
.PP
Because this option requires additional pattern
matching on every input line, and is only
occasionally needed, the default is
.BI CHECK =0
to suppress the check.
.PP
Sample options:
.RS
.nf
.BI CHECK =0
.BI CHECK =1
.fi
.RE
.\"---------------------------------------------------------------------
.SS Clipping
If a zero value of the
.BI CLIP =clip
option is given, suppress clipping the figure to
the BoundingBox.
.PP
Although EPS-including programs are supposed to
provide this clipping automatically, not all do
so.  Thus, the default in this program is to turn
on clipping.
.PP
The clipping path is set after geometric
transformations have been completed, but before
any drawing operations are performed.  Thus, the
BoundingBox frame, and the background color, are
subject to clipping.
.PP
Sample options:
.RS
.nf
.BI CLIP =0
.BI CLIP =1
.fi
.RE
.\"---------------------------------------------------------------------
.SS Grid
A non-zero value for the
.BI GRID =grid
option requests that a grid be drawn over the
picture to allow convenient determination of
BoundingBox coordinates for a portion of the view.
.PP
Clipping is automatically suppressed when a grid
is selected, in order for the complete grid, with
its edge labels, to be visible.
.PP
Sample options:
.RS
.nf
.BI GRID =0
.BI GRID =1
.fi
.RE
.\"---------------------------------------------------------------------
.SS "Identifying label"
When working with large numbers of figures, or
experimenting with various options, it is
sometimes difficult to keep track of them.  The
.B ID
option can be specified to provide a page location
where an identifying label recording the command
line will be printed.  The label location is
measured on the output page, relative to the
lower-left corner, independent of geometric
transformations.  It is drawn before any
background fill color is supplied, and will be
overwritten by that fill if it lies within the
BoundingBox of the output figure.
.PP
An optional third value defines the font size
(default: 10bp), and an optional fourth value
defines the font name (default:
.IR  Helvetica ).
.PP
Values are separated by characters other than
plus, minus, digits, period, or letters.
.PP
Sample options:
.RS
.nf
.BI ID =50,750
.BI ID =0.4in/0.4in/12pt
.BI ID "='10mm 10mm 8pt Helvetica-Narrow'"
.fi
.RE
.\"---------------------------------------------------------------------
.SS "Linewidth control"
Sometimes, linewidths need adjustment, usually to
thicken them for better reproduction.  The
.B LINEWIDTHSCALE
value causes all linewidths to be multiplied by
that value.  This scaling also affects any framing
rectangle that is requested.
.PP
\*(Ps\& allows zero linewidths, which means the
thinnest line that the output device is capable of
producing.  Such linewidths would not be affected
by scaling.  Thus, a value for
.B MINLINEWIDTH
can be given to force all lines to be at least
that thick, and therefore, subject to scaling.
.PP
To prevent scaling from producing ridiculously
thick lines, a
.B MAXLINEWIDTH
value can be set to force an upper limit to
linewidths.  If not specified, it defaults to 24.
.PP
If linewidth scaling is applied to a \*(Ps\& file
that already has linewidth scaling, the two
scalings are
.I not
cumulative: only the last scaling applied will
have any effect.  This unfortunate irregularity is
a consequence of the inability of the \*(Ps\&
language to permit redefinition of an operator to
more than one level; attempts to do otherwise
simply produce infinite loops in the \*(Ps\&
interpreter.
.PP
Sample options:
.RS
.nf
.BI LINEWIDTHSCALE =3
.BI MAXLINEWIDTH =6
.BI MAXLINEWIDTH =6bp
.BI MINLINEWIDTH =0.1pt
.fi
.RE
.\"---------------------------------------------------------------------
.SS "\*(Ps\& insertions"
Two options,
.B PSCODE
and
.BR PSFILE ,
provide for insertion of additional \*(Ps\& code
into the end of the
.I "%%BeginProlog \&.\|.\|. %%EndProlog"
section where \*(Ps\& commands are defined.
.PP
The value of
.B PSCODE
is a string containing arbitrary literal \*(Ps\&
code.
.PP
The value of
.B PSFILE
is the name of one or more comma- or
space-separated files whose contents are to be
inserted.
.PP
When both options are specified,
.B PSFILE
is handled before
.BR PSCODE ,
so that any \*(Ps\& read from files can be
overridden by literal \*(Ps\& from the command
line.
.PP
Sample options:
.RS
.nf
.BI PSCODE "='0 1 0 setrgbcolor'"
.BI PSCODE "='/setrgbcolor {add add 3 div setgray} bind def'"
.BI PSFILE =mymacros.eps
.BI PSFILE "=header1.eps,../tools/monochrome.eps"
.fi
.RE
.\"---------------------------------------------------------------------
.SS Rotation
The
.B ROTATE
option value is a rotation angle in degrees,
positive counterclockwise, and negative clockwise.
Only multiples of +/-90 degrees are supported.
Non-conforming values will elicit a warning and
be ignored, preventing any rotation.
.PP
For example, to turn landscape orientation with
the right side at the top of the page into
portrait orientation, specify
.BI ROTATE =-90.
It will usually be necessary to supply additional
scaling
.RB ( HEIGHT
or
.BR WIDTH ,
or
.BR SX ,
.BR SY ,
or
.B SXY
options) to make the picture fit on the output
page.
.PP
Unless otherwise specified by the translation
variables (see below), the position of the
lower-left corner of the BoundingBox on the output
display device is kept invariant, so that after a
-90-degree rotation, the lower-right corner of the
original BoundingBox will be positioned where the
lower-left corner was.
.PP
Sample options:
.RS
.nf
.BI ROTATE =0
.BI ROTATE =-90
.BI ROTATE =90
.BI ROTATE =180
.BI ROTATE =270
.BI ROTATE =360
.BI ROTATE =450
.fi
.RE
.\"---------------------------------------------------------------------
.SS Translation
The origin option variables move the lower-left
corner of the BoundingBox to
.RB ( OX,OY ),
relative to the lower-left page corner,
or if
.B OX
and
.B OY
are not specified, then to
.RB ( OXY,OXY ).
Otherwise, the lower-left corner of the new
BoundingBox will be at the same physical
page location as one of the corners of the
original picture; which one depends on the
rotation angle chosen.
.PP
Sample options:
.RS
.nf
.BI OX =0
.BI OY =0
.BI OX =10mm
.BI OY =36bp
.BI OXY =1in
.BI OXY =3pc
.fi
.RE
.\"---------------------------------------------------------------------
.SS "Scaling (Absolute)"
The
.BI HEIGHT =height
and
.BI WIDTH =width
options provide a way to request absolute scaling
of the BoundingBox to a specified height or width.
If only one of them is given, then the other is
computed to preserve the aspect ratio for
distortion-free scaling.  If both are given, then
the horizontal and vertical scale factors may be
different; the aspect ratio will then not be
preserved.
.PP
The two sizes refer to the final figure,
.I after
any rotation.
.PP
If both absolute
.RB ( HEIGHT
and
.BR WIDTH )
and relative
.RB ( SX ,
.BR SY ,
and
.BR SXY )
scaling are specified, then absolute scaling is
done, and the relative scale factors are ignored.
.PP
Sample options:
.RS
.nf
.BI HEIGHT =400bp
.BI HEIGHT =15cm
.BI WIDTH  =340
.BI WIDTH  =150mm
.fi
.RE
.\"---------------------------------------------------------------------
.SS "Scaling (Relative)"
The
.BR SX ,
.BR SY ,
and
.B SXY
options provide for relative
scaling.  Any scale factors provided are applied
.I after
the rotation, so that they apply to the
final figure.
.B SX
and
.B SY
are used if provided; otherwise,
.B SXY
is used for both
.I x
and
.I y
scaling if provided.
.PP
Sample options:
.RS
.nf
.BI SX =0.5
.BI SY =2.0
.BI SXY =0.7727
.fi
.RE
.\"=====================================================================
.SH "HAND MODIFICATION"
The output file can be easily modified by hand
later to adjust any of the options that can be set
on the command line.  Look for the lines following
the first
.I %%BeginProlog
comment that begin
.IR "/NAME \&.\|.\|. def" ,
and then change the numeric values as needed.
Comment lines precede each set of related variable
definitions to provide suitable documentation.
.\"=====================================================================
.SH BUGS
Until a valid
.I %%BoundingBox
comment has been
located, or a
.B BOUNDINGBOX
command-line option has
been supplied, the input \*(Ps\& is buffered in
memory.  On small machines, or with very large
\*(Ps\& files that contain the
.I %%BoundingBox
comment near the end instead of near the
beginning, it is possible that your computer
memory (and swap space, if any), might be
exceeded.  The easiest solution for such a problem
is to supply a command-line
.B BOUNDINGBOX
value.
This problem is expected to be exceedingly rare.
.PP
Encapsulated \*(Ps\& is a subset of standard
\*(Ps\&, and excludes approximately twenty
operators whose use can prevent successful
inclusion of a \*(Ps\& inside another \*(Ps\&
file, usually because those operators would
obviate the use of a local independently-scaled
coordinate system, or would modify the global
state of the \*(Ps\& environment.  When the
output file fails to conform to the specified
transformations, it is usually because of the use
of these excluded operators.
If requested by the
.BI CHECK =1
option,
.B epsutil
looks for those operators, and will raise warnings
when they are seen.  Unfortunately, their apparent
absence does not mean that they are not used,
because \*(Ps\& files can also contain binary,
hexadecimal, and other encodings that can hide
such operators from view.  Thus, the only truly
reliable check is visual examination of the output
of
.B epsutil
with a \*(Ps\& previewer or printer, and its
successful incorporation in other documents, such
as with \*(Te\&
.I \eepsffile
or
.I \especial
commands, or in word processors.
.\"======================================================================
.SH "ENVIRONMENT VARIABLES"
.TP \w'RGBPATH'u+2n
RGBPATH
Search path (a colon-separated list of
directories) for the X Window System color
definition file,
.IR rgb.txt .
.\"=====================================================================
.SH FILES
.TP \w'\fIrgb.txt\fP'u+3n
.I rgb.txt
Color mapping file distributed with the X Window
System.
.\"=====================================================================
.SH AVAILABILITY
The master source distribution for
.B epsutil
is maintained at the Internet archive
location
.IR ftp://ftp.math.utah.edu/pub/misc/index.html#epsutil-1.00
for both anonymous ftp and World-Wide Web access.
The source code is in the public domain, and
copies of the program may be freely distributed
and used for any purpose.
.\"=====================================================================
.SH "SEE ALSO"
.BR dvialw (1),
.BR dvips (1),
.BR enscript (1),
.BR genscript (1),
.BR ghostscript (1),
.BR gs (1),
.BR lptops (1),
.BR pageview (1),
.BR plot79 (1),
.BR postscript (7),
.BR psposter (1),
.BR tek2ps (1),
.BR tekalw (1),
.BR transcript (1),
.BR x79ps (1),
.BR xpsview (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
Department of Mathematics
University of Utah
Salt Lake City, UT 84112
USA
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: <beebe@math.utah.edu>
URL: http://www.math.utah.edu/~beebe
.fi
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
